"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var mongodb_1 = require("mongodb");
var mongo_entity_1 = require("./mongo_entity");
var db = null;
var name = '';
var host = '127.0.0.1';
var port = '27017';
var initContext = null;
var testServer;
var verbose;
var dbName = function () { return "tmp" + Math.floor(Math.random() * 10000); };
function config(_a) {
    var mongoHost = _a.mongoHost, testDbName = _a.testDbName, mongoPort = _a.mongoPort, verbose = _a.verbose, ic = _a.initContext, ts = _a.testServer;
    host = mongoHost || host;
    port = mongoPort || port;
    initContext = ic || initContext;
    testServer = ts || testServer;
    verbose = verbose;
    dbName = testDbName || dbName;
}
exports.config = config;
function getDb() {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (db) {
                        return [2, db];
                    }
                    name = dbName();
                    if (verbose) {
                        console.log('New connection to ' + name);
                    }
                    return [4, mongodb_1.MongoClient.connect("mongodb://" + host + ":" + port + "/" + name)];
                case 1:
                    db = _a.sent();
                    global.db = db;
                    return [2, db];
            }
        });
    });
}
exports.getDb = getDb;
function withEntity(test, options) {
    return __awaiter(this, void 0, void 0, function () {
        var connector, entities, i, option, name_1, type, entity, _i, _a, data, ex_1;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4, getConnector()];
                case 1:
                    connector = _b.sent();
                    entities = [];
                    if (!(options && options.entities)) return [3, 8];
                    i = 0;
                    _b.label = 2;
                case 2:
                    if (!(i < options.entities.length)) return [3, 7];
                    option = options.entities[i];
                    name_1 = option.name;
                    type = option.type ? option.type : mongo_entity_1.default;
                    entity = new type(connector, name_1 ? name_1 : "test_" + i);
                    entities.push(entity);
                    if (!options.entities[i].data) return [3, 6];
                    _i = 0, _a = options.entities[i].data;
                    _b.label = 3;
                case 3:
                    if (!(_i < _a.length)) return [3, 6];
                    data = _a[_i];
                    return [4, entity.insertOne(data)];
                case 4:
                    _b.sent();
                    _b.label = 5;
                case 5:
                    _i++;
                    return [3, 3];
                case 6:
                    i++;
                    return [3, 2];
                case 7: return [3, 9];
                case 8:
                    entities.push(new mongo_entity_1.default(connector, 'test'));
                    _b.label = 9;
                case 9:
                    _b.trys.push([9, 11, 12, 14]);
                    return [4, test.apply(void 0, entities)];
                case 10:
                    _b.sent();
                    return [3, 14];
                case 11:
                    ex_1 = _b.sent();
                    throw ex_1;
                case 12: return [4, entities.forEach(function (e) { return e.deleteMany({}); })];
                case 13:
                    _b.sent();
                    return [7];
                case 14: return [2];
            }
        });
    });
}
exports.withEntity = withEntity;
function itWithEntity(name, func, options) {
    it(name, function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, withEntity(function (context) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4, func(context)];
                                case 1:
                                    _a.sent();
                                    return [2];
                            }
                        }); }); }, options)];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        });
    });
}
exports.itWithEntity = itWithEntity;
var fakeConnector = {
    collection: function () {
        return {
            deleteMany: function () { },
            insert: function () { },
            find: function () { },
            findOne: function () { }
        };
    }
};
function withContext(test, initContextFn, disconnected) {
    if (disconnected === void 0) { disconnected = false; }
    return __awaiter(this, void 0, void 0, function () {
        var connector, _a, context, ex_2, _i, _b, key;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    if (!disconnected) return [3, 1];
                    _a = fakeConnector;
                    return [3, 3];
                case 1: return [4, getConnector()];
                case 2:
                    _a = _c.sent();
                    _c.label = 3;
                case 3:
                    connector = _a;
                    initContext = initContextFn || initContext;
                    if (!initContext) {
                        throw new Error('No initContext provided, please pass as a parameter or use global config');
                    }
                    context = initContext(connector);
                    _c.label = 4;
                case 4:
                    _c.trys.push([4, 6, 7, 12]);
                    return [4, test(context)];
                case 5:
                    _c.sent();
                    return [3, 12];
                case 6:
                    ex_2 = _c.sent();
                    throw ex_2;
                case 7:
                    _i = 0, _b = Object.keys(context);
                    _c.label = 8;
                case 8:
                    if (!(_i < _b.length)) return [3, 11];
                    key = _b[_i];
                    if (!(context[key] && context[key].dispose)) return [3, 10];
                    return [4, context[key].dispose({}, true)];
                case 9:
                    _c.sent();
                    _c.label = 10;
                case 10:
                    _i++;
                    return [3, 8];
                case 11: return [7];
                case 12: return [2];
            }
        });
    });
}
exports.withContext = withContext;
function itWithContext(name, func, initContextFn, disconnected) {
    it(name, function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, withContext(function (context) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4, func(context)];
                                case 1:
                                    _a.sent();
                                    return [2];
                            }
                        }); }); }, initContextFn, disconnected)];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        });
    });
}
exports.itWithContext = itWithContext;
function withServer(test, server) {
    return __awaiter(this, void 0, void 0, function () {
        var ex_3, _i, _a, key;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    if (server) {
                        testServer = server;
                    }
                    else {
                        server = testServer;
                    }
                    if (!server) {
                        throw new Error('No server provided, please pass as a parameter or use global config');
                    }
                    if (!!server.started) return [3, 2];
                    return [4, server.startTest()];
                case 1:
                    _b.sent();
                    _b.label = 2;
                case 2:
                    _b.trys.push([2, 4, 5, 10]);
                    return [4, test(server)];
                case 3:
                    _b.sent();
                    return [3, 10];
                case 4:
                    ex_3 = _b.sent();
                    throw ex_3;
                case 5:
                    _i = 0, _a = Object.keys(server.context);
                    _b.label = 6;
                case 6:
                    if (!(_i < _a.length)) return [3, 9];
                    key = _a[_i];
                    if (!(server.context[key] && server.context[key].dispose)) return [3, 8];
                    return [4, server.context[key].dispose({}, true)];
                case 7:
                    _b.sent();
                    _b.label = 8;
                case 8:
                    _i++;
                    return [3, 6];
                case 9: return [7];
                case 10: return [2];
            }
        });
    });
}
exports.withServer = withServer;
function itWithServer(name, func, server) {
    it(name, function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, withServer(function (context) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4, func(context)];
                                case 1:
                                    _a.sent();
                                    return [2];
                            }
                        }); }); }, server)];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        });
    });
}
exports.itWithServer = itWithServer;
function getConnector() {
    return __awaiter(this, void 0, void 0, function () {
        var myDb;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, getDb()];
                case 1:
                    myDb = _a.sent();
                    return [2, {
                            collection: function (name) {
                                return db.collection(name);
                            }
                        }];
            }
        });
    });
}
exports.getConnector = getConnector;
function stopDatabase() {
    return __awaiter(this, void 0, void 0, function () {
        var myDb;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    myDb = db;
                    db = null;
                    if (!myDb) return [3, 3];
                    return [4, myDb.dropDatabase()];
                case 1:
                    _a.sent();
                    return [4, myDb.close()];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3: return [2];
            }
        });
    });
}
exports.stopDatabase = stopDatabase;
function stopServer() {
    if (!testServer) {
        console.error("No server to stop!");
    }
    console.log('Stopping test server');
    testServer.stopTest();
}
exports.stopServer = stopServer;
